// C Source File
// Created 3/28/2002; 11:44:43 AM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	static unsigned char you[]={0xFE,0xFF,0xFE};
	static unsigned char bad[]={0x40,0xE0,0x40};
	unsigned int py=50;
	unsigned int badx[32]={200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200};
	unsigned int bady[32]={200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200,200};
	unsigned long int score=0;
	void *kbq = kbd_queue ();
	unsigned short key;
	unsigned short dir=2;
	unsigned short made=0;
	unsigned short a;
	unsigned short picked;
	unsigned short quitting=0;
	randomize();
	ClrScr();
	DrawLine(0,0,LCD_WIDTH,0,A_NORMAL);
	DrawLine(0,1,LCD_WIDTH,1,A_NORMAL);
	DrawLine(0,LCD_HEIGHT-1,LCD_WIDTH,LCD_HEIGHT-1,A_NORMAL);
	DrawLine(0,LCD_HEIGHT-2,LCD_WIDTH,LCD_HEIGHT-2,A_NORMAL);
	Sprite8(0,py,3,you,LCD_MEM,SPRT_XOR);
	while (1==1){
		OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 1);
		while (!OSTimerExpired (USER_TIMER));
		if (!OSdequeue (&key, kbq)){
    	if (key==KEY_UP){
    		dir=1;
    	}
    	if (key==KEY_DOWN){
    		dir=3;
    	}
    	if (key==KEY_F1){
    		dir=2;
    	}
    	if (key==KEY_CLEAR||key==KEY_ESC){
    		break;
    	}
  	}
  	Sprite8(0,py,3,you,LCD_MEM,SPRT_XOR);
  	if (dir==1&&py!=0){
  		py-=2;
  	}
  	if (dir==3&&py!=LCD_HEIGHT-4){
  		py+=2;
  	}
  	Sprite8(0,py,3,you,LCD_MEM,SPRT_XOR);
  	made++;
  	picked=100;
  	if (made==5){
  		for (a=0;a<=31;a++){
  			if (badx[a]==200){
  				picked=a;
  				break;
  			}
  		}
  		if (picked!=100){
  			badx[picked]=LCD_WIDTH-3;
  			bady[picked]=random(LCD_HEIGHT-3);
  			Sprite8(badx[picked],bady[picked],3,bad,LCD_MEM,SPRT_XOR);
  		}
  		made=0;
  	}
  	for (a=0;a<=31;a++){
  		if (badx[a]!=200){
  			Sprite8(badx[a],bady[a],3,bad,LCD_MEM,SPRT_XOR);
  			badx[a]--;
  			Sprite8(badx[a],bady[a],3,bad,LCD_MEM,SPRT_XOR);
  		}
  	}
  	for (a=0;a<=31;a++){
  		if (badx[a]==0){
  			Sprite8(badx[a],bady[a],3,bad,LCD_MEM,SPRT_XOR);
  			badx[a]=200;
  			bady[a]=200;  			
  		}
  	}
  	for (a=0;a<=31;a++){
  		if (badx[a]<8){
  			if (bady[a]<=py+2&&bady[a]+2>=py){
  				quitting=1;
  				break;
  			}
  		}
  	}
  	if (py<=0||py>=LCD_HEIGHT-4||quitting==1){
  		break;
  	}
  	score++;
	}
	printf_xy(43,40,"Score:  %lu",score);
	ngetchx();
	ngetchx();
}
